function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
export var mapStatus = function mapStatus(props, field) {
  var takeStatus = function takeStatus() {
    var _field$selfErrors, _field$selfWarnings, _field$decoratorProps;
    if (!field) return;
    if (field.loading || field.validating) return 'loading';
    if ((_field$selfErrors = field.selfErrors) === null || _field$selfErrors === void 0 ? void 0 : _field$selfErrors.length) return 'error';
    if ((_field$selfWarnings = field.selfWarnings) === null || _field$selfWarnings === void 0 ? void 0 : _field$selfWarnings.length) return 'warning';
    return (_field$decoratorProps = field.decoratorProps) === null || _field$decoratorProps === void 0 ? void 0 : _field$decoratorProps.feedbackStatus;
  };
  var takeState = function takeState(state) {
    if (state === 'validating' || state === 'pending') return 'loading';
    return state;
  };
  return _objectSpread(_objectSpread({}, props), {}, {
    state: takeState(props.state) || takeStatus()
  });
};